//+------------------------------------------------------------------+
//|                                                  Pj-over RSI.mq4 |
//|                                      Copyright  2007, PRIMAjaya |
//|                                   http://primaforex.blogspot.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, PRIMAjaya"
#property link      "http://primaforex.blogspot.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  MediumBlue
#property indicator_color2  Crimson
#property indicator_color3  SkyBlue
#property indicator_color4  Orange
#property indicator_width1  4
#property indicator_width2  4
#property indicator_width3  4
#property indicator_width4  4
#property indicator_minimum 0
#property indicator_maximum 1


//---- input parameters
extern string TimeFrame       = "current time frame";
extern int    PeriodeRSI      = 17;
extern int    OverboughtLevel = 70;
extern int    OversoldLevel   = 30;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 

//---- indicator buffers
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];
double trend1[];
double trend2[];

int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,UpBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnBuffer1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,UpBuffer2); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,DnBuffer2); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,trend1);
   SetIndexBuffer(5,trend2);

   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Pj-overRSI("+PeriodeRSI+")");
   SetIndexLabel(0,"Overbought or Strong Bulls");
   SetIndexLabel(1,"Oversold or Strong Bears");
   SetIndexLabel(2,"Trend Bulls");
   SetIndexLabel(3,"Trend Bears");
   return(0);
  }

//+------------------------------------------------------------------+
//| ProSol Confirmation                                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
            
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
      int y   = iBarShift(NULL,timeFrame,Time[i]);
         double RSI0 = iRSI(NULL,timeFrame,PeriodeRSI,PRICE_CLOSE,y);
	      if (RSI0>(OverboughtLevel+OversoldLevel)/2 && RSI0<OverboughtLevel)  trend1[i] = 1;
	      if (RSI0>=OverboughtLevel)                                           trend2[i] = 1;  
	      if (RSI0<=(OverboughtLevel+OversoldLevel)/2 && RSI0>OversoldLevel)   trend1[i] =-1;
	      if (RSI0<OversoldLevel)                                              trend2[i] =-1;
	      
	      //
	      //
	      //
	      //
	      //
	      
	      UpBuffer1[i] = EMPTY_VALUE;
	      UpBuffer2[i] = EMPTY_VALUE;
	      DnBuffer1[i] = EMPTY_VALUE;
	      DnBuffer2[i] = EMPTY_VALUE;
	  
	      if (trend1[i] == 1) UpBuffer2[i] = 1; 
	      if (trend2[i] == 1) UpBuffer1[i] = 1; 
	      if (trend1[i] ==-1) DnBuffer2[i] = 1; 
	      if (trend2[i] ==-1) DnBuffer1[i] = 1; 
	  
	}
	manageAlerts();
	return(0);	
 }
                                    
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      
         if (trend1[whichBar] != trend1[whichBar+1] || trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend1[whichBar] == 1) doAlert(whichBar,"Bullish Trend");
            if (trend1[whichBar] ==-1) doAlert(whichBar,"Bearish Trend");
            if (trend2[whichBar] == 1) doAlert(whichBar,"Overbought or Strong Bulls");
            if (trend2[whichBar] ==-1) doAlert(whichBar,"Oversold or Strong Bears");
         }                
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Pj-over RSI ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Pj-over RSI " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Pj-over RSI "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
} 
 
   

